﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Xml;

namespace WarmlyLocomotive
{
    internal class LocomotiveCompareByColor : IComparer<IDrawningObject>
    {
        public int Compare(IDrawningObject? x, IDrawningObject? y)
        {
            if (x == null && y == null)
            {
                return 0;
            }
            if (x == null && y != null)
            {
                return 1;
            }
            if (x != null && y == null)
            {
                return -1;
            }
            var xLocomotive = x as DrawningObjectLocomotive;
            var yLocomotive = y as DrawningObjectLocomotive;
            if (xLocomotive == null && yLocomotive == null)
            {
                return 0;
            }
            if (xLocomotive == null && yLocomotive != null)
            {
                return 1;
            }
            if (xLocomotive != null && yLocomotive == null)
            {
                return -1;
            }
            var xEntityLocomotive = xLocomotive.GetLocomotive.Locomotive;
            var yEntityLocomotive = yLocomotive.GetLocomotive.Locomotive;
            var baseColorCompare = xEntityLocomotive.BodyColor.ToArgb().CompareTo(yEntityLocomotive.BodyColor.ToArgb());
            if(baseColorCompare != 0)
            {
                return baseColorCompare;
            }
            if(xEntityLocomotive is EntityWarmlyLocomotive xWarmlyLocomotive && yEntityLocomotive is EntityWarmlyLocomotive yWarmlyLocomotive)
            {
                var dopColorCompare = xWarmlyLocomotive.DopColor.ToArgb().CompareTo(yWarmlyLocomotive.DopColor.ToArgb());
                if (dopColorCompare != 0)
                {
                    return dopColorCompare;
                }
            }
            var speedCompare = xLocomotive.GetLocomotive.Locomotive.Speed.CompareTo(yLocomotive.GetLocomotive.Locomotive.Speed);
            if (speedCompare != 0)
            {
                return speedCompare;
            }
            return xLocomotive.GetLocomotive.Locomotive.Weight.CompareTo(yLocomotive.GetLocomotive.Locomotive.Weight);
        }
    }
}
